<?php
namespace Teknisa\SM\Controller;

use Teknisa\SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\Libs\Util\NewCode;

class Sm00003000ParamFatItEscopoController extends SMCrud
{
    protected $dataSourceName = "fct_paramfatsrvesco_widget";
    protected $newCode;
    protected $ServiceEscopoServico;

    public function __construct ($crudService, $environment, NewCode $newCode) {
        parent::__construct($crudService, $environment);
        $this->newCode = $newCode;
    }
    
    public function save(Request $request, Response $response) {
        $rows  = $request->getDataSet()->getRows();
        $nrorg = $this->environment->getNrOrg();
        foreach($rows as $row) {
            if ($row["__is_new"])
                $row["NRSEQFATUSRVESCO"] = $this->newCode->getCodeByTableName("FCT_PARAMFATSRVESCO", $nrorg, 1, 10, true);
        }
        
        parent::save($request, $response);
    }
    
}
?>