<?php

namespace Teknisa\SM\Factory;

use Doctrine\ORM\EntityManager;

class Sm00001000EnderecoPropostaFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    /**
     * Verifica se já existe um registro com o mesmo tipo de endereço que se está tentando salvar.
     * 
     * @param mixed[]
     * 
     * @return mixed[]
     */
    public function verificarSeExisteTipoEndereco($params) {
        $sql = "SELECT COUNT(*) AS EXISTE
                  FROM FCT_ENDERECOORCA
                 WHERE NRSEQORCAMENTO  = :NRSEQORCAMENTO
                   AND NRENDERECOORCA <> :NRENDERECOORCA
                   AND CDTIPOENDERECO  = :CDTIPOENDERECO
                   AND NRORG           = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
}

?>